#include <vcl.h>
#pragma hdrstop
#include "Unit1.h"
#include "mpusbapi.h"
char vid_pid[]= "vid_04d8&pid_000c";
char out_pipe[]= "\\MCHP_EP1";
char in_pipe[]= "\\MCHP_EP1";
HINSTANCE libHandle;
HANDLE myOutPipe;
HANDLE myInPipe;

AnsiString CheckInvalidHandle(void);
void LoadDLL(void);
void UnloadDLL(void);
DWORD SendReceivePacket(BYTE *SendData, DWORD SendLength, BYTE *ReceiveData,
                    DWORD *ReceiveLength, UINT SendDelay, UINT ReceiveDelay);

#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}

//---------------------------------------------------------------------------

AnsiString CheckInvalidHandle(void){
    AnsiString ret = "ok";
    if(GetLastError() == ERROR_INVALID_HANDLE){
        MPUSBClose(myOutPipe);
        MPUSBClose(myInPipe);
        myOutPipe = myInPipe = INVALID_HANDLE_VALUE;
    }else ret = "Error Code " + GetLastError();
    return ret;
}

//---------------------------------------------------------------------------

void LoadDLL(void){
    libHandle = NULL;
    libHandle = LoadLibrary("mpusbapi");
    if(libHandle == NULL){

    }else{
        MPUSBGetDLLVersion=(DWORD(*)(void))\
                    GetProcAddress(libHandle,"_MPUSBGetDLLVersion");
        MPUSBGetDeviceCount=(DWORD(*)(PCHAR))\
                    GetProcAddress(libHandle,"_MPUSBGetDeviceCount");
        MPUSBOpen=(HANDLE(*)(DWORD,PCHAR,PCHAR,DWORD,DWORD))\
                    GetProcAddress(libHandle,"_MPUSBOpen");
        MPUSBWrite=(DWORD(*)(HANDLE,PVOID,DWORD,PDWORD,DWORD))\
                    GetProcAddress(libHandle,"_MPUSBWrite");
        MPUSBRead=(DWORD(*)(HANDLE,PVOID,DWORD,PDWORD,DWORD))\
                    GetProcAddress(libHandle,"_MPUSBRead");
        MPUSBReadInt=(DWORD(*)(HANDLE,PVOID,DWORD,PDWORD,DWORD))\
                    GetProcAddress(libHandle,"_MPUSBReadInt");
        MPUSBClose=(BOOL(*)(HANDLE))GetProcAddress(libHandle,"_MPUSBClose");

        if((MPUSBGetDeviceCount == NULL) || (MPUSBOpen == NULL) ||
            (MPUSBWrite == NULL) || (MPUSBRead == NULL) ||
            (MPUSBClose == NULL) || (MPUSBGetDLLVersion == NULL) ||
            (MPUSBReadInt == NULL)){

            }
    }
    myOutPipe = MPUSBOpen(0,vid_pid,out_pipe,MP_WRITE,0);
    myInPipe = MPUSBOpen(0,vid_pid,out_pipe,MP_READ,0);
}

//----------------------------------------------------------------------------

void UnloadDLL(void)
{
    MPUSBClose(myOutPipe);
    MPUSBClose(myInPipe);
    myOutPipe = myInPipe = INVALID_HANDLE_VALUE;
}

//---------------------------------------------------------------------------

DWORD SendReceivePacket(BYTE *SendData, DWORD SendLength, BYTE *ReceiveData,
                    DWORD *ReceiveLength, UINT SendDelay, UINT ReceiveDelay){
    DWORD SentDataLength;
    DWORD ExpectedReceiveLength = *ReceiveLength;
    if(myOutPipe != INVALID_HANDLE_VALUE && myInPipe != INVALID_HANDLE_VALUE){
        if(MPUSBWrite(myOutPipe,SendData,SendLength,&SentDataLength,SendDelay)){
            if(MPUSBRead(myInPipe,ReceiveData, ExpectedReceiveLength,
                        ReceiveLength,ReceiveDelay)){
                if(*ReceiveLength == ExpectedReceiveLength){
                    return 1;   // Success!
                }else if(*ReceiveLength < ExpectedReceiveLength){
                    return 2;   // Partially failed, incorrect receive length
                }//end if else
            }else CheckInvalidHandle();
        }else CheckInvalidHandle();
    }//end if

    return 0;  // Operation Failed
}//end SendReceivePacket

//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
    LoadDLL();        
}

//---------------------------------------------------------------------------






void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
    int tm = 0;
    BYTE send_buf[64],receive_buf[64],set_out = 0x00;
    DWORD RecvLength=5;
    send_buf[0] = 0x01;      // Command
    send_buf[1] = 0xFF;      //  B
    send_buf[2] = 0xC7;      //  C
    SendReceivePacket(send_buf,3,receive_buf,&RecvLength,150,150);
    if(!receive_buf[3]) receive_buf[3] == 0x01;
    tm = ( receive_buf[1] >> 1 ) * 100 + 75 - receive_buf[2] * 100 / receive_buf[3];

    if(receive_buf[0])Label1->Caption = "-";
        else Label1->Caption = "+";
    Label2->Caption = (int)(tm / 100);       //   
    Label4->Caption = (int)((tm / 10) % 10); //  
    // receive_buf[4]; //  
}
//---------------------------------------------------------------------------

