
/** I N C L U D E S **********************************************************/
#include <p18cxxx.h>

#include "system\typedefs.h"
#include "wire1.h"
#include "system\usb\usb.h"

#include "io_cfg.h"             // I/O pin mapping
#include "user\user.h"



/** V A R I A B L E S ********************************************************/
#pragma udata
byte counter;
byte termo0 = 0x00;
byte termo1 = 0x00;
byte termo6 = 0x00;
byte termo7 = 0x00;
DATA_PACKET dataPacket;




/** P R I V A T E  P R O T O T Y P E S ***************************************/

void BlinkUSBStatus(void);
void ServiceRequests(void);
byte ReadPorts(void);



/** D E C L A R A T I O N S **************************************************/
#pragma code



void UserInit(void)
{
    TRISA &= 0b00011111; LATA &= 0b00000000;
    TRISB &= 0b00000000; LATB &= 0b00000000;
    TRISC &= 0b00111000; LATC &= 0b00000000;
}





void ProcessIO(void)
{   
    BlinkUSBStatus();
    if((usb_device_state < CONFIGURED_STATE)||(UCONbits.SUSPND==1)) return;
    ServiceRequests();
}







void ServiceRequests(void) {

    int tm = 0;

    if(USBGenRead((byte*)&dataPacket,sizeof(dataPacket))) {

        counter = 0;
	
	if(dataPacket.CMD == PKTBYTE){	 //               0x01
		
		LATB = dataPacket.ID1;
		LATC = dataPacket.ID2;

	    	if(wire1_ready()) { 
	       		wire1_write_byte (0xCC);					
	        	wire1_write_byte (0xBE);	
	        	termo0 = wire1_read_byte ();  //   
	        	termo1 = wire1_read_byte ();  //  
			  wire1_read_byte ();wire1_read_byte ();
			  wire1_read_byte ();wire1_read_byte ();
	        	termo6 = wire1_read_byte ();	//    ()
	        	termo7 = wire1_read_byte ();
	    	}else{
			termo0 = 0x00;
			termo1 = 0x00;
			termo6 = 0x00;
			termo7 = 0x00;
		}
           dataPacket._byte[0] = termo1;   //  
	    if (termo1) termo0 = (0xFF - termo0) + 2;
           dataPacket._byte[1] = termo0;
           dataPacket._byte[2] = termo6;
           dataPacket._byte[3] = termo7;
	    dataPacket._byte[4] = ReadPorts();
           counter=0x05;	// 5 

 	} else if(dataPacket.CMD == RESET) Reset();	
        
        if(counter != 0){
              if(!mUSBGenTxIsBusy())
                USBGenWrite((byte*)&dataPacket,counter);
        }
    }

}





void BlinkUSBStatus(void)
{
    static word led_count=0;
    if(led_count == 0){
	  led_count = 40000U;
	  LATAbits.LATA5 = !PORTAbits.RA5;
	  if(wire1_ready()) {
	       wire1_write_byte (0xCC);					
	       wire1_write_byte (0x44);
	  }
    }
    led_count--;
}




byte ReadPorts(void)
{
	byte out = 0x00;
	if(!PORTAbits.RA1) out += 0b00000001;
	if(!PORTAbits.RA2) out += 0b00000010;
	if(!PORTAbits.RA3) out += 0b00000100;
	if(!PORTAbits.RA4) out += 0b00001000;
	return out;
}
