#include	<delays.h>

#define Delay480us      Delay1KTCYx(5);Delay100TCYx(8); //1  == 83.3333333 
#define Delay55us       Delay100TCYx(6);Delay10TCYx(6);
#define Delay40us       Delay100TCYx(4);Delay10TCYx(8);
#define Delay21us       Delay100TCYx(2);Delay10TCYx(6);
#define Delay5us        Delay10TCYx(6);
#define Delay2us        Delay10TCYx(2);Delay1TCY();Delay1TCY();Delay1TCY();Delay1TCY();


#define WIRE1_OUT LATAbits.LATA0
#define WIRE1_IN PORTAbits.RA0
#define WIRE1_TRIS TRISAbits.TRISA0

void wire1_init(void) {
	WIRE1_TRIS = 1;											//   
}

/*	    */
void wire1_reset_pulse(void) {
	WIRE1_TRIS = 0;
	WIRE1_OUT = 0;
  	Delay480us;         //   
	WIRE1_OUT = 1;
	WIRE1_TRIS = 1;											//  
}

/*	   
 *	    0     1   
*/
byte wire1_ready(void) {
	char count;

	wire1_reset_pulse();									//  

	count = 0;
	while (!WIRE1_IN) {									//    1  
		if (count >=12) {return 0;}						//    (70) - 
		count++;									        		//   - 
		Delay5us;
	}

	Delay5us;Delay5us;Delay5us;           // 15 
  
	count = 0;
	while (WIRE1_IN) {									//    1  
		if (count >=50) {return 0;}						//  0   (250 ) - 
		count++;											        //   - 
		Delay5us;
	}

  	Delay480us;
	WIRE1_OUT = 1;
	WIRE1_TRIS = 1;											// 

	return 1;												//    1
}

/*	  
 *
*/
void wire1_write_byte(unsigned char c) {
  byte cnt;											//
  byte tmp_c;										//  

	for (cnt = 0; cnt<8; cnt++) {
		WIRE1_TRIS = 0;										// 
		WIRE1_OUT = 0;										//  (0  2 )
		Delay2us;
		tmp_c = c;
		tmp_c = tmp_c & 0b00000001;
		if (tmp_c == 1) {WIRE1_OUT = 1;}					//     60 
		c = c>>1;
		Delay55us;
		WIRE1_OUT = 1;										//   1    1
		Delay40us;
	}
	WIRE1_OUT = 1;
	WIRE1_TRIS = 1;											// 
}

/*	  
 *
*/
byte wire1_read_byte(void) {
byte c;
byte cnt;											//

	c = 0;
	for (cnt = 0; cnt<8; cnt++) {
		WIRE1_TRIS = 0;										// 
		WIRE1_OUT = 0;										//  (0  2 )
		Delay2us;
		WIRE1_OUT = 1;
		WIRE1_TRIS = 1;	// ,    
    
    		Delay21us;

		c = c>>1;
		if (WIRE1_IN) {c = c | 0b10000000;}			//      
		Delay55us;									//    									//
		WIRE1_TRIS = 0;										// 
		WIRE1_OUT = 1;										//   1  1
		Delay40us;
	}
	WIRE1_OUT = 1;
	WIRE1_TRIS = 1;											// 
	return c;
}

